# class Gem::Resolver::APISet

The global rubygems pool, available via the rubygems.org API. Returns instances of APISpecification.

### Attributes

source [R]

The `Gem::Source` that gems are fetched from

uri [R]

The corresponding place to fetch gems.

### Public Class Methods

new (dep_uri = "https://index.rubygems.org/info/")
Source

    # File lib/rubygems/resolver/api_set.rb, line 30
    def initialize(dep_uri = "https://index.rubygems.org/info/")
      super()

      dep_uri = Gem::URI dep_uri unless Gem::URI === dep_uri

      @dep_uri = dep_uri
      @uri     = dep_uri + ".."

      @data   = Hash.new {|h,k| h[k] = [] }
      @source = Gem::Source.new @uri

      @to_fetch = []
    end

Creates a new `APISet` that will retrieve gems from `uri` using the RubyGems API URL `dep_uri` which is described at guides.rubygems.org/rubygems-org-api

Calls superclass method `BasicObject::new`

### Public Instance Methods

find_all (req)
Source

    # File lib/rubygems/resolver/api_set.rb, line 48
    def find_all(req)
      res = []

      return res unless @remote

      if @to_fetch.include?(req.name)
        prefetch_now
      end

      versions(req.name).each do |ver|
        if req.dependency.match? req.name, ver[:number], @prerelease
          res << Gem::Resolver::APISpecification.new(self, ver)
        end
      end

      res
    end

Return an array of APISpecification objects matching DependencyRequest `req`.

prefetch (reqs)
Source

    # File lib/rubygems/resolver/api_set.rb, line 70
    def prefetch(reqs)
      return unless @remote
      names = reqs.map {|r| r.dependency.name }
      needed = names - @data.keys - @to_fetch

      @to_fetch += needed
    end

A hint run by the resolver to allow the `Set` to fetch data for DependencyRequests `reqs`.

### Private Instance Methods

lines (str)
Source

    # File lib/rubygems/resolver/api_set.rb, line 129
    def lines(str)
      lines = str.split("\n")
      header = lines.index("---")
      header ? lines[header + 1..-1] : lines
    end

parse_gem (string)
Source

    # File lib/rubygems/resolver/api_set.rb, line 135
    def parse_gem(string)
      @gem_parser ||= GemParser.new
      @gem_parser.parse(string)
    end